/*
 * DSP_functions.c
 *
 *  Created on: 28.jun.2009
 *      Author: Stian O. Moen
 */

#include "dsp.h"
#include "DSP_functions.h"
#include "config.h"
#include "ADC_functions.h"
#include "TC_functions.h"


//The DC level of the signal for the 1.5V regualtor
A_ALIGNED dsp16_t dc_offset = 465;

//will reuturn a struct containing the frequency of the highest power with
//the assisated power. The rreturn frequency is scaled to acount for the
//undersampling.
FreqPower_t find_dominating_frequency(dsp16_complex_t *complex_vector)
{
	dsp16_t vector_abs[NUMBER_OF_SAMPLES];
	dsp16_vect_complex_abs(vector_abs, complex_vector, NUMBER_OF_SAMPLES);
	//dsp16_debug_print_vect(vector_abs, NUMBER_OF_SAMPLES);
	//find highest value
	dsp16_t max_value = dsp16_vect_max(vector_abs, NUMBER_OF_SAMPLES);
	//find the location of the highest value

	int i = 0;
	char exit = FALSE;
	while (exit == FALSE)
	{
		i++;
		if (max_value == vector_abs[i] || i >= NUMBER_OF_SAMPLES)
			exit = TRUE;
	}
	FreqPower_t return_value;
	//calculate the alias frequency in kHz for 64 point two sided FFT
	return_value.freq = (i*(F_SMP/2)/32.0)/1000.0+F_SMP/1000.0;

	return_value.power = max_value;
	return return_value;
}

//The function will perform a sample burst, remove the DC offset and
//find the dominating frequency and assosiated power. This frequency
//and power is returned
FreqPower_t check_signal(void)
{
	A_ALIGNED dsp16_complex_t vect1[NUMBER_OF_SAMPLES];
	enable_sampling();
	while(sample_flag == TRUE);
	//remove DC
	int i;
	for (i = 0; i < NUMBER_OF_SAMPLES; i++)
	{
		sample[i] -= dc_offset;
	}


	dsp16_trans_realcomplexfft(vect1, sample, NLOG);
	return find_dominating_frequency(vect1);
}
