/*
 * SPI_functions.h
 *
 *  Created on: 30.jun.2009
 *      Author: Stian O. Moen
 */

#ifndef SPI_FUNCTIONS_H_
#define SPI_FUNCTIONS_H_


//Specifies chip select order
#define DIGPOT1_CS	0
#define DIGPOT2_CS	1
#define DIGPOT3_CS	2
#define DIGPOT4_CS	3
#define FLASH_CS	0



//dataflash defines
#define CMD_WRITE_BUFFER_1				0x84
#define CMD_BUFFER1_TO_MEM_WITH_ERASE	0x83
#define CMD_MAIN_PAGE_READ				0xD2
#define DATAFLASH_PAGE_SIZE				528

//Prototypes
void update_potentiometer(unsigned char potentiometer, char data);
void set_gain(U32 gain);
void set_threshold(unsigned char data);
void init_SPI(void);
unsigned char store_data_in_dataflash(unsigned char *data, unsigned short size);
unsigned char read_data_from_dataflash(unsigned char *data, unsigned short size);

#endif /* SPI_FUNCTIONS_H_ */
