/*
 * TC_functions.c
 *
 *  Created on: 22.jun.2009
 *      Author: Stian O. Moen
 */



#include "tc.h"
#include "TC_functions.h"
#include "compiler.h"
#include "gpio.h"
#include "intc.h"
#include "USART_functions.h"
#include "ADC_functions.h"
#include <AVR32/io.h>
#include "ADC_functions.h"
#include "adc.h"

//Global variables
volatile avr32_tc_t *tc = &AVR32_TC;


//initializes the timer counter to the options set in WAVEFORM_OPT.
//the timer is used to generate a hardware signal on timer/counter
//channel 0, triggering an ADC conversion.
void init_TC( void )
{
	  // Initialize the timer/counter waveform.
	  tc_init_waveform(tc, &WAVEFORM_OPT);
	  tc_write_ra(tc, TC_CHANNEL, 10); //assign a low value to reset TIOA
	  //Set ADC samplig frequency
	  tc_write_rc(tc, TC_CHANNEL, (F_TIM / 4) / F_SMP);
	  //ensure that the timer is stopped and reset so the sampling does not start
	  tc_stop(tc, TC_CHANNEL);
}

//This function will enable timer counter channel 0 to trigger an ADC conversion
// by hardware through TIOA
void enable_sampling(void)
{
	//include reset of timer
	sample_nr = 0;
	sample_flag = TRUE;
	//enable ADC complete interrupt
	volatile avr32_adc_t *adc = &AVR32_ADC;
	ENABLE_ADC_INTERRUPT();
	tc_start(tc, TC_CHANNEL);                    // Start the timer/counter.
}

//this function will stop the timer and disable the ADC interrupt
void disable_sampling(void)
{
	tc_stop(tc, TC_CHANNEL);                    // Stop the timer/counter and reset counter
	sample_flag = FALSE;
	volatile avr32_adc_t *adc = &AVR32_ADC;
	DISABLE_ADC_INTERRUPT();
}
