/*
 * test_functions.c
 *
 *  Created on: 16.jul.2009
 *      Author: Stian O. Moen
 */

#include <avr32\io.h>
#include "gpio.h"
#include "usart.h"
#include "pm.h"
#include "USART_functions.h"
#include "config.h"
#include "CLOCK_functions.h"
#include "stdio.h"
#include "tc.h"
#include "TC_functions.h"
#include "adc.h"
#include "ADC_functions.h"
#include "dsp.h"
#include "DSP_functions.h"
#include "intc.h"
#include "dsp_debug.h"
#include "SPI_functions.h"
#include "spi.h"
#include "rtc.h"
#include "RTC_functions.h"
#include "eic.h"
#include "EIC_functions.h"
#include "TEST_functions.h"


//this function includes the code needed to provide the functionality and performance
//tests. To prevent interference between tests comment out the tests that are not
//to be performed only leaving one test. The complete system test is implemented
//to the system using the standard setup.
void test(void)
{
/*
//test #5
	set_gain(1);
	set_gain(10);
	set_gain(100);
	set_gain(200);

//test #6
	set_gain(1);
	set_gain(10);
	set_gain(100);
	set_gain(200);

//test #7
	set_gain(100);
	set_threshold(70);

//test #8
	usart_write_line(USB_USART, "Test successful\n");

//test #9
	int i;
	for(i =0; i < 20; i++)
	{
		volatile time_variable_t time = get_time();
		usart_putchar(USB_USART, time.millisec);
	}

//test #10
	//create data set and store to flash
	unsigned char flash_store_data[512];
	for (i = 0; i < 512; i++)
	{
		flash_store_data[i] = 0x55;
	}
	store_data_in_dataflash(flash_store_data, sizeof(flash_store_data));

	//read data black from flash
	unsigned char flash_read_data[512];
	for(i = 0; i < 512; i++)
	{
		flash_read_data[i] = 0;
	}
	read_data_from_dataflash(flash_read_data, sizeof(flash_read_data));

	//validate data
	char flag = 0;
	for(i = 0; i < 512; i++)
	{
		if (flash_read_data[i] != flash_store_data[i])
			flag = 1;
	}
	if (flag == 1)
		usart_write_line(USB_USART, "Flash FAIL with 0x55\n");
	else
		usart_write_line(USB_USART, "Flash OK with 0x55\n");

	//Perform same test with data = 0x11
	for (i = 0; i < 512; i++)
	{
		flash_store_data[i] = 0x11;
	}
	store_data_in_dataflash(flash_store_data, sizeof(flash_store_data));

	//read data black from flash
	read_data_from_dataflash(flash_read_data, sizeof(flash_read_data));

	//validate data
	flag = 0;
	for(i = 0; i < 512; i++)
	{
		if (flash_read_data[i] != flash_store_data[i])
			flag = 1;
	}
	if (flag == 1)
		usart_write_line(USB_USART, "Flash FAIL with 0x11\n");
	else
		usart_write_line(USB_USART, "Flash OK with 0x11\n");

//test #11
	set_gain(1);
	set_gain(2);
	set_gain(5);
	set_gain(10);
	set_gain(20);
	set_gain(50);
	set_gain(100);
	set_gain(200);
	set_gain(500);
	set_gain(1000);
	set_gain(2000);
	set_gain(5000);
	set_gain(10000);
	set_gain(20000);
	set_gain(50000);
	set_gain(100000);
	set_gain(140000);

//test #12
	set_gain(10);
	//SLEEP(AVR32_PM_SMODE_STATIC); //uncomment when performing test 12.

//test #13
	set_gain(1);
	set_gain(2);
	set_gain(5);
	set_gain(10);
	set_gain(20);
	set_gain(50);
	set_gain(100);
	set_gain(200);
	set_gain(500);
	set_gain(1000);
	set_gain(2000);
	set_gain(5000);
	set_gain(10000);
	set_gain(20000);
	set_gain(50000);
	set_gain(100000);
	set_gain(140000);

//test #14
	set_gain(1);
	set_gain(2);
	set_gain(5);
	set_gain(10);
	set_gain(20);
	set_gain(50);
	set_gain(100);
	set_gain(200);
	set_gain(500);
	set_gain(1000);
	set_gain(2000);
	set_gain(5000);
	set_gain(10000);
	set_gain(20000);
	set_gain(50000);
	set_gain(100000);
	set_gain(140000);

//test #15
	set_gain(1);

//test #16
	set_gain(1);

//test #17
	set_gain(1);

//test #18
	gpio_set_gpio_pin(LED1);
	enable_sampling();
	while(sample_flag == TRUE);
	gpio_clr_gpio_pin(LED1);

	unsigned char test[512];
	gpio_set_gpio_pin(LED1);
	store_data_in_dataflash(test, sizeof(test));
	gpio_clr_gpio_pin(LED1);

	gpio_set_gpio_pin(LED1);
	set_gain(12000);
	gpio_clr_gpio_pin(LED1);


	gpio_set_gpio_pin(LED1);
	time_variable_t time = get_time();
	gpio_clr_gpio_pin(LED1);

	time_variable_t time2 = get_time();
	gpio_set_gpio_pin(LED1);
	calculate_time_diff(time2, time);
	gpio_clr_gpio_pin(LED1);

	A_ALIGNED dsp16_complex_t vect1[NUMBER_OF_SAMPLES];
	gpio_set_gpio_pin(LED1);
	FreqPower_t test_freq =  find_dominating_frequency(vect1);
	gpio_clr_gpio_pin(LED1);

	gpio_set_gpio_pin(LED1);
	signed short temp_level  = get_signal_level();
	gpio_clr_gpio_pin(LED1);
*/
//test #19; NB! should be performed without any initialization in main()
	enable_all_pullups();
	init_RTC();
	SLEEP(AVR32_PM_SMODE_DEEP_STOP);
}

void enable_all_pullups(void)
{
	//gpio_enable_pin_pull_up(AVR32_PIN_PA03);
	//gpio_enable_pin_pull_up(AVR32_PIN_PA04);
	gpio_enable_pin_pull_up(AVR32_PIN_PA07);
	gpio_enable_pin_pull_up(AVR32_PIN_PA13);
	gpio_enable_pin_pull_up(AVR32_PIN_PA20);
	gpio_enable_pin_pull_up(AVR32_PIN_PA21);
	gpio_enable_pin_pull_up(AVR32_PIN_PA22);
	gpio_enable_pin_pull_up(AVR32_PIN_PA26);
	gpio_enable_pin_pull_up(AVR32_PIN_PA27);
	gpio_enable_pin_pull_up(AVR32_PIN_PA05);
	//gpio_enable_pin_pull_up(AVR32_PIN_PA06);
	gpio_enable_pin_pull_up(AVR32_PIN_PA25);
	gpio_enable_pin_pull_up(AVR32_PIN_PA14);
	gpio_enable_pin_pull_up(AVR32_PIN_PA15);
	gpio_enable_pin_pull_up(AVR32_PIN_PA16);
	gpio_enable_pin_pull_up(AVR32_PIN_PA17);
	gpio_enable_pin_pull_up(AVR32_PIN_PA09);
	gpio_enable_pin_pull_up(AVR32_PIN_PA10);
	gpio_enable_pin_pull_up(AVR32_PIN_PA08);
	gpio_enable_pin_pull_up(AVR32_PIN_PA23);
	gpio_enable_pin_pull_up(AVR32_PIN_PA24);

	//oscillator pins
	gpio_enable_pin_pull_up(AVR32_PIN_PA18);
	gpio_enable_pin_pull_up(AVR32_PIN_PA19);
	gpio_enable_pin_pull_up(AVR32_PIN_PA11);
	gpio_enable_pin_pull_up(AVR32_PIN_PA12);


}
