/*
FILE:			USART_functions.c
PROJECT:		Telemetry Buoy project
DESCRIPTION:	Includes functions for debug-output as well as output of data
DATE:			17.06.09
AUTHOR:			Stian O. Moen
*/


#include "USART_functions.h"
#include "config.h"

//This function initializes the USART to communicate with the USB-UART bridge
//Requires that the clock source is initialized
void init_USART(void)
{
	  static const gpio_map_t USART_GPIO_MAP =
	  {
	    {USB_USART_RX_PIN, USB_USART_RX_FUNCTION},
	    {USB_USART_TX_PIN, USB_USART_TX_FUNCTION}
	  };

	  // Assign GPIO to USART.
	  gpio_enable_module(USART_GPIO_MAP,
	                     sizeof(USART_GPIO_MAP) / sizeof(USART_GPIO_MAP[0]));

	  // Initialize USART in RS232 mode. Must be changed if PLL setup is altered
	  usart_init_rs232(USB_USART, &USART_OPTIONS, F_CPU/2);
}




