%Script that gives the bode responce of the variable gain amplifier
%and filter designed by the intuitive solution
clc
clear all
%wiper position (0 means top, full input signal)
hold on
N = 0.0;
%potentiometer end-to-end resistance
RP = 100e3;
%high pass capacitor value
C1 = 5.6e-12
%desired lower corner frequency [Hz]
f0 = 60000;
%filter resistor value
R1 = 1/(C1*2*pi*f0)

%low pass filter resistor value
R3 = 423.3e3;
R2 = 17637;
%low pass filter capacitor value
C2 = 4.7e-12;

%Wiper resistance
RW = 250;
%Wiper capacitance
CW = 25e-12;

%calculate potentimeter resistor values.
RL = RP*(1-N)
RH = RP*N


%transfer function for an ideal potentiometer and high pass filter
Hi = tf([RL*R1*C1 0],[C1*(R1*RL+RH*RL+RH*R1) RH+RL])

%transfer function for high pass filter without potentiometer
Hp = tf([R1*C1 0],[R1*C1 1])

%transfer function for an non-ideal potentiometer with HP-filter
Hni= tf([RL*R1*C1 0],[CW*C1*R1*((RL+RW)*RH+RL*RW) (((C1+CW)*RL+(RW+R1)*C1+RW*CW)*RH+((RW+R1)*C1+RW*CW)*RL) RL+RH])


%Transferfunction for the Active low pass filter with gain
G = 1+tf([R3],[R2*R3*C2 R2]);
hold on

%Plot transfer functions

P = bodeoptions;
P.PhaseVisible = 'off';
P.FreqUnits = 'Hz';
P.Xlim = [1000 500000];
P.Title.String = 'Potentiometer with high pass filter';

jadda = 'jadda';

figure(1);
subplot(2,2,1);
bode(Hni,P);
P.Title.String = 'Active low pass filter with gain';
subplot(2,2,2);
title('Active Low Pass');
bode(G,P);
P.Title.String = 'Combined potentiometer, HP and LP';
subplot(2,2,3);
title('Combined one link');
bode(G*Hni,P);
bode(Hp*Hlp,P); only for testing
P.Title.String = 'Complete AGC with 4 gain stages, 3 potentiometes and 4 HP';
subplot(2,2,4);
title('Full AGC responce');
bode(Hni*G*Hni*G*Hni*G*Hp*G,P);


%Calculate poles as a function of potentiometer position.
K = 255;
for k=1:K
    RL = RP*(1-k/K);
    RH = RP*k/K;
    den = [CW*C1*R1*((RL+RW)*RH+RL*RW) (((C1+CW)*RL+(RW+R1)*C1+RW*CW)*RH+((RW+R1)*C1+RW*CW)*RL) RL+RH];
    r_temp = -roots(den)/(2*pi);
    r1(k) = r_temp(1);
    r2(k) = r_temp(2);
end

%check that the upper pole does not efffect the frequency band of interesst
lowest_high_pole = min(r1)

%check the crossoverfreqeuncy variation
variation = max(r2)-min(r2)

